/*
 * Filename: Intseq.h
 * Author:   ratn1
 * Created:  Tue Sep 18 13:54:29 2007
 * $Id: Intseq.h,v 1.2 2008/01/30 01:51:41 pratn Exp $
 */
#ifndef __INTSEQ_H__
#define __INTSEQ_H__

#ifdef __cplusplus
#include "stack_sig.h"
#include <vector>
using namespace std;

typedef long int value_t;
#define PRIvalINT "ld"
#define VALUE_DATATYPE MPI_LONG //MPI_LONG_INT is {long, int}

class Intseq
{
private:
  int k;            /* number of lower k bits to chop off */
  value_t k_mask;
  vector<value_t> * vect;
  void init ();

  stack_sig signature;

  int my_rank, min_rank, max_rank;

public:
  Intseq ();
  ~Intseq ();
  Intseq (long int dest_time, int ignore,
	  const stack_sig *sig, int my_rank, int min_rank, int max_rank);

  int get_packed_size (MPI_Comm comm) const;
  void pack (void* buf, int bufsize, int *postition, MPI_Comm comm);

  static Intseq * unpack (void * buf, int bufsize, int* postition, MPI_Comm comm);

  void merge (const Intseq *other);

  int sig_match (const Intseq *other) {
    return SIG_MATCH(signature, other->signature);
  }

  int sig_match (const stack_sig *sig) {
    return SIG_MATCH(signature, *sig);
  }

  int output (char *buf);
  int add (value_t v, int rank);
};

extern "C" {
#endif

  void* intseq_input(char *buf);
#ifdef __cplusplus
}
#endif

#endif
/* vim: set tw=80 sw=2 expandtab: */
