#ifndef __SCALARPARAMLIST_H__
#define __SCALARPARAMLIST_H__

#include <vector>
#include "RList.h"
#include <mpi.h>
#include <iostream>
#include "Param.h"

class ScalarParamList {

private:
  std::vector<MPIParam> values;
  RList *rank_list;

public:
  ScalarParamList() { }

  ~ScalarParamList();

  ScalarParamList( std::vector<MPIParam> v, int *rlist); 

  int get_packed_size(MPI_Comm comm);

  void pack(void *buf, int bufsize, int *position, MPI_Comm comm); 

  void unpack(void *buf, int bufsize, int *position, MPI_Comm comm);

  RList * get_rlist() { return rank_list; }

  void merge_rlist(RList *r);

  int match(ScalarParamList *s );

  int output(char * buf);
};

#endif 
