#ifndef _PARAMS_QUEUE_H
#define _PARAMS_QUEUE_H

#include <stdio.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct params_node_t
{
  int offset;

  struct params_node_t *next;
  struct params_node_t *prev;
} params_node;

typedef struct
{
  params_node *head;
  params_node *tail;
  params_node *cur;

  int update_flag;
} params_queue;

void init_params_node(params_node *node);

void init_params_queue(params_queue *queue);
void params_push(params_queue *queue, int offset);
void params_push_replay(params_queue *queue, params_node *new_tail);
params_node *params_pop(params_queue *queue);
int soutput_params(char *buf, int len, params_queue *queue);
void free_params_queue(params_queue *queue);

int params_queue_compare(params_queue *queue1, params_queue *queue2);
void undo_addition(params_queue *queue);
void reset_flag(params_queue *queue);

#ifdef __cplusplus
}
#endif
#endif
