/*
 * Filename: cvector.h
 * Author:   prasun
 * Created:  Tue Jul  1 13:58:50 2008
 * $Id: cvector.h,v 1.2 2008/09/25 10:49:47 pratn Exp $
 */
#ifndef __PVECTOR_H__
#define __PVECTOR_H__

typedef enum {
  Undo_none,
  Undo_pos,
  Undo_iters
} vector_info_type;

#ifdef __cplusplus
extern "C" {
#include <vector>

using namespace std;
template<class T>
class pvector {
  public:
    vector<T> v;
    int iterations;

    // used during replay
    int current;

    // used for undoing speculative merge
    vector_info_type t;
    int undo_iter;
    vector<T>::iterator undo_pos;
    
    cvector (T a);
    cvector ();

    T get_next () {
      T val = v[current];
      current = (current + 1)% v.size();
      return val;
    }
};
  
#endif
/*
typedef struct cvector cvector;

void vector_init (cvector ** c, int a);
void vector_free (cvector ** c);
void vector_push_back (cvector * c, int a);
int  vector_get_next (cvector * c);
int *     vector_to_array ( cvector * c,    int * size);
cvector * array_to_vector ( int64_t * arr,  int   size);
int vector_output (char *buf, cvector *c);

int vector_match_first (cvector * c, int a);
int vector_match (cvector *c, cvector *d);
int vector_increment_count (cvector * c);
int vector_concat (cvector *c, cvector *d);
void vector_undo_info (cvector * c, vector_info_type t);
void vector_undo_addition (cvector ** c, int * a);
void vector_reset_undo_info (cvector * c);

int vector_packed_size(cvector *c, MPI_Comm comm);
void vector_pack(cvector *c, void *buf, int bufsize, int *position, MPI_Comm
    comm);
cvector* vector_unpack(void *buf, int bufsize, int *position, MPI_Comm comm);
*/
#ifdef __cplusplus
}
#endif

#endif
/* vim: set tw=80 sw=2 expandtab: */
