#ifndef REQ_HANDLER_H
#define REQ_HANDLER_H

#include <stdio.h>
#include <mpi.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct req_handler{
  MPI_Request *req_buf;
  int req_bufsize;
  int req_bufcur;
} * req_handler_t;

extern int my_rank;

void init_req(req_handler_t * req,int size);
void add_request_entry(req_handler_t req, MPI_Request request);
void finalize_req(req_handler_t req);

void reset_offset (req_handler_t req, int offset);
void reset_internal(req_handler_t req, int *offsets, int *indices, int count);
void lookup_request(req_handler_t req, int offset, int null_request, MPI_Request *request);
void lookup_requestlist(req_handler_t req, int *offsets, int count, int null_request, MPI_Request *requests);
void lookup_requestlist_waitsome(req_handler_t req, int *offsets, int count, int null_request, MPI_Request *requests);
void lookup_offset(req_handler_t req, MPI_Request request, int *offset);
void lookup_offsetlist(req_handler_t req, MPI_Request *requests, int count, int *offsets, int reset);

#ifdef __cplusplus
}
#endif
#endif
