/*
 * Filename: utils.h
 * Author:   pratn
 * Created:  Thu Jun 28 16:33:15 2007
 * $Id: utils.h,v 1.3 2008/03/17 16:44:00 pratn Exp $
 */
#ifndef __UTILS_H__
#define __UTILS_H__

#ifndef ARRAY_SIZE
# define ARRAY_SIZE(a) (sizeof(a)/sizeof(a[0]))
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define foreach(a, list) for (a = list; a; a = a->next)

// copied from sys/time.h on GNU/Linux 
/* Convenience macros for operations on timevals.
   NOTE: `timercmp' does not work for >= or <=.  */
#ifndef timerisset
# define timerisset(tvp)  ((tvp)->tv_sec || (tvp)->tv_usec)
#endif
#ifndef timerclear
# define timerclear(tvp)  ((tvp)->tv_sec = (tvp)->tv_usec = 0)
#endif
#ifndef timercmp
# define timercmp(a, b, CMP)                  \
  (((a)->tv_sec == (b)->tv_sec) ?                 \
   ((a)->tv_usec CMP (b)->tv_usec) :                \
   ((a)->tv_sec CMP (b)->tv_sec))
#endif
#ifndef timeradd
# define timeradd(a, b, result)                 \
  do {                        \
    (result)->tv_sec = (a)->tv_sec + (b)->tv_sec;           \
    (result)->tv_usec = (a)->tv_usec + (b)->tv_usec;            \
    if ((result)->tv_usec >= 1000000)               \
      {                       \
  ++(result)->tv_sec;                 \
  (result)->tv_usec -= 1000000;               \
      }                       \
  } while (0)
#endif
#ifndef timersub
# define timersub(a, b, result)                 \
  do {                        \
    (result)->tv_sec = (a)->tv_sec - (b)->tv_sec;           \
    (result)->tv_usec = (a)->tv_usec - (b)->tv_usec;            \
    if ((result)->tv_usec < 0) {                \
      --(result)->tv_sec;                 \
      (result)->tv_usec += 1000000;               \
    }                       \
  } while (0)
#endif

#endif /* __UTILS_H__  */
/* vim: set tw=80 sw=2 expandtab: */
