#include <iostream>
#include "RandomVector.h"

using std::cout; using std::endl;
using std::vector;

RandomVector::RandomVector(int s, int sz) {
  seed = s;
  size = sz;
  curr_ptr = 0;
  fill_rand();
}

int RandomVector::get_rand_max(long long max) {

  if(curr_ptr == size ) {
    fill_rand();
  }
  double retval = (((double)value[curr_ptr] / ((double)(RAND_MAX)+(double)(1)) ) * (max));
  curr_ptr++;
  return (int)retval;
}

void RandomVector::fill_rand() {
  srand(seed);
  value.clear();
  for(int i = 0; i < curr_ptr; i++) {
    rand();
  }
  for(int i = 0; i < size; i++) {
    value.push_back( rand() );
  }
  curr_ptr = 0;
}

void init_rand_vector(RandomVector ** rvec, int seed, int size) {
  (*rvec) = new RandomVector(seed, size);
}

int get_rand_max(RandomVector *rvec, long long max) {
  return rvec->get_rand_max(max);
}


/*int main() {
  using namespace std;
  RandomVector r(321, 5);
  RandomVector r2(321, 5);
  for(int i = 0; i < 5; i++)
    cout << r.get_rand_max(200) << " " ;

  cout << endl;
  for(int i = 0; i < 5; i++)
    cout << r2.get_rand_max(200) << " " ;

  cout << endl;
  for(int i = 0; i < 5; i++)
    cout << r.get_rand_max(200) << " " ;

  cout << endl;
  for(int i = 0; i < 5; i++)
    cout << r2.get_rand_max(200) << " " ;

  cout << endl;

}*/
