#include "VectorParam.h"
#include <iostream>
using std::vector;
using std::cout; using std::endl;

//template <class MPIParam>
VectorParam::VectorParam(int *arr_param, int size) {

  for(int i = 0; i < size; i++) {
    value.push_back( MPIParam( arr_param[i] ) );
  }
}

//template <class MPIParam>
VectorParam& VectorParam::operator= (const VectorParam&) {
  //cout << "VectorParam: Inside =operator implementation" << endl;
}

//template <class MPIParam>
VectorParam::VectorParam(const VectorParam&) {
  //cout << "VectorParam: Inside copy constructor" << endl;
}

//template <class MPIParam>
VectorParam::~VectorParam() {
  //cout << "VectorParam: Inside destructor" << endl;
  value.clear();
}

//template <class MPIParam>
void VectorParam::add (MPIParam val) {
  //cout << "VectorParam: Inside add function" << endl;
  //value = val;
}

//template <class MPIParam>
void VectorParam::add_histo (MPIParam value) {
  //cout << "VectorParam: Inside add_histo function" << endl;
}

int VectorParam::compare (GenericParam<MPIParam>& m1) {

  vector<MPIParam>* slave_vec = (vector<MPIParam>*)m1.getValueList();
  if(value.size() != slave_vec->size()) {
    return 0;
  }
  int diff = 0;
  typedef vector<MPIParam>::iterator vec_it;
  vec_it m_iter;
  vec_it s_iter;
  for(m_iter = value.begin(), s_iter = slave_vec->begin();
      m_iter != value.end(), s_iter != slave_vec->end();
      ++m_iter, ++s_iter) {
    MPIParam mp = *m_iter;
    MPIParam sp = *s_iter;
    if(!compareMPIParam( &mp, &sp, &diff ))
      return 0;
  }
  return 1;
}

void VectorParam::printValue() {
  //cout << "VectorParam: Inside printValue" << endl;
}

int VectorParam::soutput_param(char *buf) {
  char *pos = buf;
  pos += sprintf(pos, "%d ", value.size());
  for(vector<MPIParam>::iterator it = value.begin();
       it != value.end(); ++it) {
    pos += it->soutput_value(pos);
    pos += sprintf(pos, " ");
  }
  return (pos-buf);
}

int VectorParam::param_packed_size(MPI_Comm comm) {
  int size = 0;
  size += packed_size(1, MPI_INT, comm); //size of vector
  
  for(vector<MPIParam>::iterator it = value.begin();
       it != value.end(); ++it) {
    size += it->get_packed_size(comm);
  }
  return size;
}

void VectorParam::unpack(void *buf, int bufsize, int *position, MPI_Comm comm) {

  int size = 0;
  PMPI_Unpack(buf, bufsize, position, &size, 1, MPI_INT, comm);
  if(size > 0) {
    for(int i=0; i<size; i++) {
      MPIParam mp;
      mp.unpack(buf, bufsize, position, comm);
      value.push_back(mp);
    }
  }
}

void VectorParam::pack(void *buf, int bufsize, int *position, MPI_Comm comm){
  int size = 0;
  size = value.size();
  PMPI_Pack(&size, 1, MPI_INT, buf, bufsize, position, comm);
  
  if(size > 0) {
    for(vector<MPIParam>::iterator it = value.begin();
         it != value.end(); ++it) {
      it->pack(buf, bufsize, position, comm);
    }
  }
}
