/*
 * Filename: normal_dist.c
 * Author:   pratn
 * Created:  Tue Jun 12 12:02:46 2007
 * $Id: normal_dist.c,v 1.2 2008/01/30 01:51:41 pratn Exp $
 */
#include <assert.h>
#include <math.h>
#include "rand_max.h"

double normal_dist ( double mu, double sigma)
{
  assert (sigma > 0);

  double p, p1, p2;

  do
  {
    p1 = rand_max(2) - 1 ;
    p2 = rand_max(2) - 1 ;

    p = p1 * p1 + p2 * p2;
  } while ( p >= 1);

  return mu + sigma * p1 * sqrt ( (-2) * log (p) / p );
}

double normal_dist_range ( double min, double max, double mu, double sigma)
{
  double value = 0;

  do
  {
    value = normal_dist ( mu, sigma);
  }
  while (!((value < max) && (value > min)));

  return value;
}

/* vim: set tw=80 ts=2 sw=2 expandtab: */
