/*
 * Filename: op_info.c
 * Author:   pratn
 * Created:  Tue Apr 10 01:54:40 2007
 * $Id: op_info.c,v 1.2 2008/01/30 01:51:41 pratn Exp $
 */
#include "umpi_internal.h"

int is_wait (int op)
{
  switch (op)
  {
    case umpi_MPI_Wait :
    case umpi_MPI_Waitall :
    case umpi_MPI_Waitsome :
      return 1;
    default:
      return 0;
  }
}

int is_async (int op)
{
  switch (op)
  {
    case umpi_MPI_Ibsend :
    case umpi_MPI_Iprobe :
    case umpi_MPI_Irecv :
    case umpi_MPI_Irsend :
    case umpi_MPI_Isend :
    case umpi_MPI_Issend :
      return 1;
    default:
      return 0;
  }
}
 
int is_collective (int op)
{
  switch (op)
  {
    case umpi_MPI_Allgather :
    case umpi_MPI_Allgatherv :
    case umpi_MPI_Allreduce :
    case umpi_MPI_Alltoall :
    case umpi_MPI_Alltoallv :
    case umpi_MPI_Barrier :
    case umpi_MPI_Finalize :
    case umpi_MPI_Gather :
    case umpi_MPI_Gatherv :
    case umpi_MPI_Reduce :
    case umpi_MPI_Reduce_scatter :
    case umpi_MPI_Scatter :
    case umpi_MPI_Scatterv :
      return 1;
    default:
      return 0;
  }
}

/* vim: set tw=80 ts=2 sw=2 expandtab: */
