#include "params.h"

int params_match(replay_op *params1, replay_op *params2)
{
  int i, retval = MATCH;
  //printf("params_match: Ops are %d, %d\n", params1->op, params2->op);
  /* check arrays all match */
  if(params1->arrays != params2->arrays)
    retval |= MFAIL_ARR;

  if(params1->arrays != NO_ARRAYS) {
    if(params1->array_size1 != params2->array_size1)
      retval |= MFAIL_ARR;
    else {
      for(i = 0; i < params1->array_size1; i++) {
        if(params1->array1[i] != params2->array1[i]) {
          retval |= MFAIL_ARR;
          break;
        }
      }
    }

    if(params1->array_size2 != params2->array_size2)
      retval |= MFAIL_ARR;
    else {
      for(i = 0; i < params1->array_size2; i++)
        if(params1->array2[i] != params2->array2[i]) {
          retval |= MFAIL_ARR;
          break;
        }
    }

    if(params1->array_size3 != params2->array_size3)
      retval |= MFAIL_ARR;
    else {
      for(i = 0; i < params1->array_size3; i++) 
        if(params1->array3[i] != params2->array3[i]) {
          retval |= MFAIL_ARR;
          break;
        }
    }

    if(params1->array_size4 != params2->array_size4)
      retval |= MFAIL_ARR;
    else {
      for(i = 0; i < params1->array_size4; i++)
        if(params1->array4[i] != params2->array4[i]) {
          retval |= MFAIL_ARR;
          break;
        }
    }
  }

  /* check all gen params match */
  if ((params1->fields & GLOBAL_WORLD) 
      && (params1->global_world != params2->global_world))    retval |= MFAIL_GEN;
  if ((params1->fields & NULL_REQ) 
      && (params1->null_req != params2->null_req))            retval |= MFAIL_GEN;
  if ((params1->fields & COMM) 
      && (params1->comm != params2->comm))                    retval |= MFAIL_GEN;
  if ((params1->fields & COUNT) 
      && (params1->count != params2->count)) {
                 retval |= MFAIL_CNT;
  }
  if ((params1->fields & COUNT)
      && (!vector_match (params1->count_vector, params2->count_vector))) {
                                                              retval |= MFAIL_CNT;
  }
  if ((params1->pvectors & COUNT)||(params2->pvectors & COUNT)) {
                                                              retval |= MFAIL_CNT;
  }
  if ((params1->fields & DATATYPE) 
      && (params1->datatype != params2->datatype))            retval |= MFAIL_GEN;
  if ((params1->fields & RECVCOUNT) 
      && (params1->recvcount != params2->recvcount))          retval |= MFAIL_GEN;
  if ((params1->fields & RECVTYPE) 
      && (params1->recvtype != params2->recvtype))            retval |= MFAIL_GEN;
  if ((params1->fields & MPI_OP) 
      && (params1->mpi_op != params2->mpi_op))                retval |= MFAIL_GEN;
  if ((params1->fields & ROOT) 
      && (params1->root != params2->root))                    retval |= MFAIL_ROOT;
  if ((params1->fields & ROOT)
      && (!vector_match (params1->root_vector, params2->root_vector))) {
                                                              retval |= MFAIL_ROOT;
  }
  if ((params1->pvectors & ROOT)||(params2->pvectors & ROOT)) {
                                                              retval |= MFAIL_ROOT;
  }
  if ((params1->fields & TAG) 
      && (params1->tag != params2->tag))                      retval |= MFAIL_GEN;
  if ((params1->fields & DEST) 
      && (params1->dest != params2->dest))                    retval |= MFAIL_DST;
  if ((params1->fields & DEST)
      && (!vector_match (params1->dest_vector, params2->dest_vector)))
                                                              retval |= MFAIL_DST;
  if ((params1->pvectors & DEST)||(params2->pvectors & DEST))
                                                              retval |= MFAIL_DST;
  if ((params1->fields & REQUEST) 
      && (params1->request != params2->request))              retval |= MFAIL_REQ;
  if ((params1->fields & REQUEST)
      && (!vector_match (params1->request_vector, params2->request_vector)))
                                                              retval |= MFAIL_REQ;
  if ((params1->fields & GROUP) 
      && (params1->group != params2->group))                  retval |= MFAIL_GEN;
  if (has_rank_offset ((*params1), COLOR) != has_rank_offset ((*params2), COLOR))
                                                              retval |= MFAIL_CLR;
  if ((params1->fields & COLOR) 
      && (params1->color != params2->color))                  retval |= MFAIL_CLR;
  if (has_rank_offset ((*params1), KEY) != has_rank_offset ((*params2), KEY))
                                                              retval |= MFAIL_KEY;
  if ((params1->fields & KEY) 
      && (params1->key != params2->key))                      retval |= MFAIL_KEY;
  if ((params1->fields & GROUP1) 
      && (params1->group1 != params2->group1))                retval |= MFAIL_GEN;
  if ((params1->fields & GROUP2) 
      && (params1->group2 != params2->group2))                retval |= MFAIL_GEN;
  if ((params1->fields & LOCAL_LEADER) 
      && (params1->local_leader != params2->local_leader))    retval |= MFAIL_GEN;
  if ((params1->fields & PEER_COMM) 
      && (params1->peer_comm != params2->peer_comm))          retval |= MFAIL_GEN;
  if ((params1->fields & REMOTE_LEADER) 
      && (params1->remote_leader != params2->remote_leader))  retval |= MFAIL_GEN;
  if ((params1->fields & HIGH) 
      && (params1->high != params2->high))                    retval |= MFAIL_GEN;
  if ((params1->fields & SOURCE) 
      && (params1->source != params2->source))                retval |= MFAIL_SRC;
  if ((params1->fields & SOURCE)
      && (!vector_match (params1->source_vector, params2->source_vector)))
                                                              retval |= MFAIL_SRC;
  if ((params1->pvectors & SOURCE)||(params2->pvectors & SOURCE))
                                                              retval |= MFAIL_SRC;
  if ((params1->fields & RECVTAG) 
      && (params1->recvtag != params2->recvtag))              retval |= MFAIL_GEN;
  if ((params1->fields & NEWTYPE) 
      && (params1->newtype != params2->newtype))              retval |= MFAIL_GEN;
  if ((params1->fields & OLDTYPE) 
      && (params1->oldtype != params2->oldtype))              retval |= MFAIL_GEN;
  if ((params1->fields & BLOCKLEN) 
      && (params1->blocklen != params2->blocklen))            retval |= MFAIL_GEN;
  if ((params1->fields & STRIDE) 
      && (params1->stride != params2->stride))                retval |= MFAIL_GEN;
  if ((params1->fields & REORDER) 
      && (params1->reorder != params2->reorder))              retval |= MFAIL_GEN;
  if ((params1->fields & NEWRANK) 
      && (params1->newrank != params2->newrank))              retval |= MFAIL_GEN;
  if ((params1->fields & OUTCOUNT) 
      && (params1->outcount != params2->outcount))            retval |= MFAIL_GEN;

  //Added by Karthik - Start
  #ifdef FEATURE_FILE_IO
  if((params1->fields_extn & OFFSET)
     && (params1->offset != params2->offset))
     /*&& ((params1->offsetinfo.startpos!=0 && params2->offsetinfo.startpos!=0 && params1->offsetinfo.startpos != params2->offsetinfo.startpos)
         || (params1->offsetinfo.stride!=0 && params2->offsetinfo.stride!=0 && params1->offsetinfo.stride != params2->offsetinfo.stride)
         || (params1->offsetinfo.totalcount!=0 && params2->offsetinfo.totalcount!=0 &&params1->offsetinfo.totalcount != params2->offsetinfo.totalcount)))*/
                                                              retval |= MFAIL_OFF;
  if((params1->fields_extn & FILENAME) && params1->filepath && params2->filepath && params1->filename && params2->filename
     && ((strcmp(params1->filepath,params2->filepath)!=0)
         || (strcmp(params1->filename,params2->filename)!=0)))   retval |= MFAIL_FLN;

  /*if((params1->fields_extn & DISP)
     && (params1->datarep != params2->datarep))               retval |= MFAIL_DISP;

  if((params1->fields_extn & DISP)
     && (!vector_match (params1->datarep, params2->datarep))) retval |= MFAIL_DISP; 

  if((params1->pvectors & DISP)||(params2->pvectors & DISP))  retval |= MFAIL_DISP;*/

  if((params1->fields_extn & DISP)
     && (params1->disp != params2->disp))               
	retval |= MFAIL_DISP;

  if((params1->fields_extn & DISP)
     && (!vector_match (params1->disp_vector, params2->disp_vector))) 
	retval |= MFAIL_DISP; 

  if((params1->pvectors & DISP)||(params2->pvectors & DISP))  
	retval |= MFAIL_DISP;
  #endif
  //Added by Karthik - End

  return retval;
}
