/* Umpire wrappers for all traceable POSIX functions */

/* !!!!! This file is automatically generated by a wrapper-engine !!!!! */

#include <setjmp.h>
#include <errno.h>
#include <sys/types.h>
#include <stdio.h>
#include "umpi_internal.h"

#include "internal.h"

#include "umpi_pc.h"

extern int is_mpi_inited;

/*--------------------------------------------- write */

extern ssize_t  __real_write(  int fd ,
		const void *buf ,
		size_t count );

static int
posix_write_immediate_local_pre(umpi_op_t *op)
{

{
{
  init_op (&operation);
  recordTime (&operation, 0);
}
}
return 0;
}


static int
posix_write_pre( 
void * pc , int fd ,
const void *buf ,
size_t count )

{
int rc = 0;
umpi_op_t *uop = (umpi_op_t *)calloc(sizeof(umpi_op_t), 1);

assert(uop);
uop->op = umpi_write;
uop->rank = umpi_rank;
uop->seq_num = umpi_task_seq_num++;
uop->pc = pc;
		uop->data.mpi.fd = fd;
uop->data.mpi.buf = (void*)buf;
		uop->data.mpi.count = count;
umpi_inc_ref_count (uop);
#ifdef UMPI_DEBUG_LEVEL_2
q_append (umpi_task_op_q, uop);
#endif

uop->order = umpi_preop;

rc = posix_write_immediate_local_pre(uop);
umpi_dec_ref_count (uop, UMPI_TASK_SYNCHRONOUS);
return 0;
}

static int
posix_write_immediate_local_post(umpi_op_t *op)
{

{
{
  operation.fields = COUNT;
  operation.fields_extn = FH;
  operation.op = (MPI_Op_t)op->op;
  operation.seq_num = op->seq_num;
  operation.fh = file_handle_to_index (record_ptr,  op->data.mpi.fh);
  operation.count = op->data.mpi.count;
  recordTime (&operation, 1);
  compress_rsd(&op_queue, &operation);
recordTime (0, 0);}
}
return 0;
}


static int
posix_write_post( 
int MPI_rc, 
void * pc , int fd ,
const void *buf ,
size_t count )

{
int rc = 0;
umpi_op_t *uop = (umpi_op_t *)calloc(sizeof(umpi_op_t), 1);

assert(uop);
uop->op = umpi_write;
uop->rank = umpi_rank;
uop->seq_num = umpi_task_seq_num++;
uop->pc = pc;
		uop->data.mpi.fd = fd;
uop->data.mpi.buf = (void*)buf;
		uop->data.mpi.count = count;
umpi_inc_ref_count (uop);
#ifdef UMPI_DEBUG_LEVEL_2
q_append (umpi_task_op_q, uop);
#endif

uop->order = umpi_postop;
uop->res = MPI_rc;

rc = posix_write_immediate_local_post(uop);
umpi_dec_ref_count (uop, UMPI_TASK_SYNCHRONOUS);
return rc;
}

static int
gwrap_write( 
void * pc , int fd ,
const void *buf ,
size_t count )
{
int rc;

if (is_mpi_inited)
posix_write_pre(pc,
			fd,
			buf,
			count);
	rc = __real_write(  (fd),
(buf),
(count));

if (is_mpi_inited)
posix_write_post(rc, pc,
			fd,
			buf,
			count);
	return rc;
}

extern ssize_t __wrap_write(  int fd ,
		const void *buf ,
		size_t count )
{
	int rc = 0;
	void *pc = 0x0;
	GET_FP;
	//DEFINE_PC;
	//GATHER_PC;
	rc = gwrap_write(pc,
			fd,
			buf,
			count );
	return rc;
}


/*eof*/
