/*
 * Filename: internal.h
 * Author:   prasun
 * Created:  Mon Mar 17 03:36:00 2008
 * $Id: internal.h,v 1.4 2008/12/26 20:44:49 gamlin Exp $
 */
#ifndef __INTERNAL_H__
#define __INTERNAL_H__

#include "opstruct.h"
#include "stack_sig.h"
#include "rsd_queue.h"
#include "rsd_compress.h"
#include "radix_tree.h"
#include "transfer.h"
#include "req_handler.h"
#include "ptr_handler.h"
#include "trace.h"
#include "mpi_util.h"

#ifdef __cplusplus
extern "C" {
#endif

/* ScalaTrace's gneral globals */
#include "config.h"

extern req_handler_t record_req;
extern FILE *output_trace;
extern rsd_queue op_queue;
extern struct timeval all_start;
extern ptr_handler_t record_ptr;
//
extern struct timeval startTime, endTime;
extern double output_time(FILE *file, const char *label);

void profile_timing ();

void output_profile_timing (FILE * file);

/* mike's preprocessor control statements */
#define TSIZE           256
#define BINARY          1
#define ASCII           2
#define RSD             3
//#define DUMP_DEBUG      1
//#define DUMPQUEUE_DEBUG 1
//#define TIMING_DEBUG   1
//#define TIMING_ALL
//#define MERGE_DEBUG    1
#ifndef COMPRESS_CROSS_NODE
#define RESULTS_TASKLEVEL 1
#endif
//#define RESULTS_MEMUSAGE  1

/**
 * Dumps the provided queue to a file labeled with the provided rank and label.
 * e.g.:
 *   dump_queue_with_label(queue, 1, 2, "sent");
 * 
 * Dumps the queue to a file called 1-2.sent, if called on node 57.
 */
void dump_queue_with_label(rsd_queue *queue, int from_rank, int to_rank, char *label);

void dump_queue_as_graph(rsd_queue *queue, int from_rank, int iter, char *label);
#ifdef __cplusplus
}
#endif
#endif
/* vim: set tw=80 sw=2 expandtab: */
