#include <string.h>
#include <stdlib.h>
#include "rank_list.h"

void soutput_ranklist(int *rlist, char *buf)
{
  int i;

  if(!rlist) {
    fprintf(stderr, "error: soutput_ranklist pass NULL rank list\n");
    exit(0);
  }
  if(!buf) {
    fprintf(stderr, "error: soutput_ranklist pass NULL buffer\n");
    exit(0);
  }
  
  sprintf(strlen(buf) + buf, "%d ", rlist[0]);
  for(i = 1; i < rlist[0]; i += 2)
    sprintf(strlen(buf) + buf, "%d-%d ", rlist[i], rlist[i + 1]);
  buf[strlen(buf) - 1] = '\0';
}

void insert_rank(int rank, int **rlist)
{
  /* new list */
  if(!*rlist) {
    *rlist = (int *) malloc(sizeof(int) * 3);
    if(!*rlist) {
      perror("insert_rank malloc");
      exit(0);
    }

    *rlist[0] = 3;
    *rlist[1] = 6;
    *rlist[2] = rank;
  }
  else {
    fprintf(stderr, "error: insert_rank should only be used on a NULL pointer\n");
    exit(0);
  }
}

int member_rank(int rank, int *rlist)
{
  int i;

  for(i = 1; i < rlist[0]; i += 2)
    if(rank >= rlist[i] && rank <= rlist[i + 1])
      return 1;

  return 0;
}
