/*
 * Filename: rsd_compress.h
 * Author:   ratn1
 * Created:  Wed Nov  7 10:37:27 2007
 * $Id: rsd_compress.h,v 1.1 2007/11/08 00:03:24 pratn Exp $
 */
#ifndef __RSD_COMPRESS_H__
#define __RSD_COMPRESS_H__

#ifdef __cplusplus
extern "C" {
#endif

/**
 * This routine runs the compression algorithm on the provided queue.
 * <p>
 * Otionally, an operation can be provided to be pushed on the queue before
 * compression begins.  
 * <p>
 * Note that compression is only done if intra-node compression is enabled. 
 * If it's not, then compression is skipped entirely, and at most this puts
 * another op on the queue.
 */
void compress_rsd(rsd_queue *queue, replay_op *operation);

int  can_merge_alltoallv (int * sendcounts, int * recvcounts,
                          MPI_Comm comm, int comm_size, int * average);

#ifdef __cplusplus
}
#endif

#endif 
/* vim: set tw=80 sw=2 expandtab: */
