#ifndef TRANSFER_H
#define TRANSFER_H

//#define DEBUG_XFER       1
//#define MERGE_TIMING_DEBUG 1
#define TBUF             4096
#define STATE_NO_CHILD   0
#define STATE_WAIT_SIZE  1
#define STATE_WAIT_DATA  2
#define STATE_DONE       3

#include <stdio.h>
#include <mpi.h>
#include "rsd_queue.h"
#include "params.h"
#include "rank_recursive.h"

#ifdef __cplusplus
extern "C" {
#endif

/* This file provides routines for transferring queues over MPI. */
void send_rsd_queue(rsd_queue *queue, MPI_Comm comm, int dest);
void recv_rsd_queue(rsd_queue *queue, MPI_Comm comm, int src);
void merge_queues(rsd_queue *master, rsd_queue *slave_head, int slave_rank);

/**
 * Helper for dealing with MPI packing.  This is a function-equivalent for
 * MPI_Pack_size.
 */ 
int packed_size(int count, MPI_Datatype type, MPI_Comm comm);

#ifdef __cplusplus
}
#endif

#endif
