/* -*- C -*- 

   @PROLOGUE@

   ----- 

   Jeffrey Vetter vetter@llnl.gov
   Center for Applied Scientific Computing, LLNL
   31 Oct 2000

   hello.c -- simple hello world app

 */

#ifndef lint
static char *rcsid = "$Header: /home/cvs/cvs/pratn/record/tests/hello.c,v 1.3 2008/08/05 21:07:56 pratn Exp $";
#endif

#include "mpi.h"
#include <stdio.h>

main (int argc, char **argv)
{
  int nprocs = -1;
  int rank = -1;
  int recvbuf = 0;
  int i, j, k;

  MPI_Init (&argc, &argv);
  MPI_Comm_size (MPI_COMM_WORLD, &nprocs);
  MPI_Comm_rank (MPI_COMM_WORLD, &rank);
  printf ("MPI comm size is %d with rank %d executing\n", nprocs, rank);
#if 0
  for (j = 0; j < 10; j++) {
    MPI_Barrier (MPI_COMM_WORLD);
    for (i = 0; i < 10; i++) {
      MPI_Reduce (&rank, &recvbuf, 1, MPI_INT, MPI_MAX, 0, MPI_COMM_WORLD);
    if (rank == 0)
    {
      printf ("Reduce max is %d\n", recvbuf);
    }
    for (k = 0; k < 10; k++)
      MPI_Barrier (MPI_COMM_WORLD);
    }
    MPI_Reduce (&rank, &recvbuf, 1, MPI_INT, MPI_MAX, 0, MPI_COMM_WORLD);
  }
#else
  for (j = 0; j < 10; j++) {
    MPI_Status status;
    MPI_Request reqs [512];
    for (i = 0; i < nprocs; i++) {
      if (i != rank) {
        MPI_Irecv (&recvbuf, 1, MPI_INT, i, 0, MPI_COMM_WORLD, &reqs[i]);
        MPI_Send (&recvbuf, 1, MPI_INT, i, 0, MPI_COMM_WORLD);
      }
    }
    for (i = 0; i < nprocs; i++) {
      if (i != rank)
      MPI_Wait (&reqs[i], &status);
    }

    MPI_Barrier (MPI_COMM_WORLD);
  }
#endif
  MPI_Finalize ();
  printf ("(%d) Finished normally\n", rank);
}


/* eof */
