#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main (int argc, char *argv[])
{
  int task;
  int numtasks;
  char **buffers;
  MPI_Request *requestlist;
  int i, j, k;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &task);
  MPI_Comm_size(MPI_COMM_WORLD, &numtasks);
  requestlist = (MPI_Request *) malloc(numtasks*sizeof(MPI_Request));
  buffers = (char **) malloc(numtasks*sizeof(char *));
  for (i=0; i<numtasks; i++)
    buffers[i] = (char *) malloc(1024);

  for (i=0; i<5; i++)
    for (j=0; j<3; j++) {
      int numrequests = 0;

      if (task == i) {
	for (k=0; k<numtasks; k++)
	  if (k != i) {
	    MPI_Irecv(buffers[numrequests], 1024, MPI_BYTE, k, 0, MPI_COMM_WORLD, &requestlist[numrequests]);
	    numrequests++;
	  }
      }
      else {
	MPI_Isend(buffers[numrequests], 1024, MPI_BYTE, i, 0, MPI_COMM_WORLD, &requestlist[numrequests]);
	numrequests++;
      }
      MPI_Waitall(numrequests, requestlist, MPI_STATUSES_IGNORE);
    }

  MPI_Finalize();
  return 0;
}

