#ifndef OP_COLLECT_H
#define OP_COLLECT_H

#include "rsd_queue.h"

#define REQ_LIST_SIZE 1000

typedef struct rsd_collect {
  rsd_node *op;
  int rank;
  int depth;
  int iter;
  int compute_time;
  int function_time;
  int is_io_op;
}rsd_collect_t;

typedef struct io_collect {
  rsd_collect_t * rsd_det;
  long long last_write_time;
  long long last_read_time;
  Histogram * write_time_diff;
  Histogram * read_time_diff;
  long long read_bytes;
  long long write_bytes;
  long long total_compute_time;
  long long total_function_time;
  long long total_time;
  long io_ops;
  long coll_comm_ops;
  long block_comm_ops;
  long nonblock_comm_ops;
  long comm_ops;
  long total_ops;
  long mpi_io_ops;
  long posix_io_ops;
  long mpi_open;
  long mpi_read;
  long mpi_write;
  long mpi_close;
  long mpi_seek;
  long mpi_view;
  long posix_open;
  long posix_read;
  long posix_write;
  long posix_close;
}io_collect_t;

#define HIST_BUCKETS 5

io_collect_t io_det;

/**
 * Decodes and executes the operation represented by the supplied rsd_node.
 * This call returns non-zero if queue replay should be terminated.
 */
int exec_prsd_call(rsd_node *op, int rank, int depth, int iter);

#endif /* OP_EXEC_H */


