#!/bin/bash 
# run replay on trace
# $Author: pratn $
# $Id: runall.sh,v 1.12 2008/03/29 06:54:59 pratn Exp $
#

TOPDIR=${HOME}/[path]/pratn
BINDIR=${TOPDIR}/src/replay
#NHISTO=debug
NASDIR=${TOPDIR}/nas-benchmarks/NPB3.2-MPI/bin

if [ `uname -n` = "ocracoke" ]; then
MPIRUN=cqsub
WDIRFLAG=-C
NUMP=n
rtime=300
TPARAM=-t\ ${rtime}
else
MPIRUN=mpirun
WDIRFLAG=-wdir
NUMP=np
fi

bin=mpip_replay
op=-X

for i in bt cg dt ep ft is lu mg
do
  if [ $i = "bt" ]; then
    cpuops=36\ 64\ 144\ 256\ 484
  else
    cpuops=32\ 64\ 128\ 256\ 512
  fi
  for ver in dump node glob
  do
    if [ ${ver} = "glob" ]; then
      op=
    else
      op=-X
    fi
    for cpu in $cpuops
    do
    WDIR=${BINDIR}/mpip/$i/${ver}/${cpu}
    rm ${WDIR}/*.error ${WDIR}/*.output
    mkdir -p $WDIR
    while [ `cqnum` -ge $BGL_MAX_JOBS ]
    do
      sleep 5
    done
    RSD=recorded_ops_${cpu}
    ${MPIRUN} ${WDIRFLAG} ${WDIR} ${TPARAM} -${NUMP} ${cpu} ${BINDIR}/${bin} -p ${NASDIR}/$i/${ver}/${cpu}/${RSD} ${op}
    done
  done
done
