#include "stackwalk/h/walker.h"
#include "stackwalk/h/frame.h"

using namespace Dyninst;
using namespace Dyninst::Stackwalker;
using namespace std;

extern intptr_t * do_stack_unwind ()
{
  // use one walker per process
  static Walker *walker = NULL;
  if (!walker) {
    walker = Walker::newWalker();
  }
  
  // not thread-safe, but we don't do threads.
  static vector<Frame> swalk;   

  // use the Wisconsin stackwalker to unwind.
  walker->walkStack(swalk);

  static int main_addr = 0;
  static int tail = 0;
  static int first = 1;

  // TODO: find a better way to locate main.
  if (first) {
    string name;

    for (int i=0; i < swalk.size(); i++) {
      swalk[i].getName(name);
      if (name == "main" || name == "_main") {
	main_addr = swalk[i].getRA();
	tail = swalk.size() - i;
	break;
      }
    }
    first = 0;
  }

  int len = swalk.size() - WRAP_DEPTH - tail;
  intptr_t * tmp_sig = new intptr_t[len + 1];
  for (unsigned i=0; i < len; i++) {
    tmp_sig[i] = swalk[i+WRAP_DEPTH].getRA();
    if (tmp_sig[i] == main_addr) {
      break; // only go to main.
    }
  }
  tmp_sig[len] = 0;

  return tmp_sig;
}

void do_stack_free (intptr_t * t)
{
  delete [] t;
}
